/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the WebhookEventContactAddress type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &WebhookEventContactAddress{}

// WebhookEventContactAddress struct for WebhookEventContactAddress
type WebhookEventContactAddress struct {
	Street *string `json:"street,omitempty"`
	StreetNumber *string `json:"street_number,omitempty"`
	DoorNumber *string `json:"door_number,omitempty"`
	City *string `json:"city,omitempty"`
	Zip *string `json:"zip,omitempty"`
	Country *string `json:"country,omitempty"`
}

// NewWebhookEventContactAddress instantiates a new WebhookEventContactAddress object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewWebhookEventContactAddress() *WebhookEventContactAddress {
	this := WebhookEventContactAddress{}
	return &this
}

// NewWebhookEventContactAddressWithDefaults instantiates a new WebhookEventContactAddress object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewWebhookEventContactAddressWithDefaults() *WebhookEventContactAddress {
	this := WebhookEventContactAddress{}
	return &this
}

// GetStreet returns the Street field value if set, zero value otherwise.
func (o *WebhookEventContactAddress) GetStreet() string {
	if o == nil || IsNil(o.Street) {
		var ret string
		return ret
	}
	return *o.Street
}

// GetStreetOk returns a tuple with the Street field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WebhookEventContactAddress) GetStreetOk() (*string, bool) {
	if o == nil || IsNil(o.Street) {
		return nil, false
	}
	return o.Street, true
}

// HasStreet returns a boolean if a field has been set.
func (o *WebhookEventContactAddress) HasStreet() bool {
	if o != nil && !IsNil(o.Street) {
		return true
	}

	return false
}

// SetStreet gets a reference to the given string and assigns it to the Street field.
func (o *WebhookEventContactAddress) SetStreet(v string) {
	o.Street = &v
}

// GetStreetNumber returns the StreetNumber field value if set, zero value otherwise.
func (o *WebhookEventContactAddress) GetStreetNumber() string {
	if o == nil || IsNil(o.StreetNumber) {
		var ret string
		return ret
	}
	return *o.StreetNumber
}

// GetStreetNumberOk returns a tuple with the StreetNumber field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WebhookEventContactAddress) GetStreetNumberOk() (*string, bool) {
	if o == nil || IsNil(o.StreetNumber) {
		return nil, false
	}
	return o.StreetNumber, true
}

// HasStreetNumber returns a boolean if a field has been set.
func (o *WebhookEventContactAddress) HasStreetNumber() bool {
	if o != nil && !IsNil(o.StreetNumber) {
		return true
	}

	return false
}

// SetStreetNumber gets a reference to the given string and assigns it to the StreetNumber field.
func (o *WebhookEventContactAddress) SetStreetNumber(v string) {
	o.StreetNumber = &v
}

// GetDoorNumber returns the DoorNumber field value if set, zero value otherwise.
func (o *WebhookEventContactAddress) GetDoorNumber() string {
	if o == nil || IsNil(o.DoorNumber) {
		var ret string
		return ret
	}
	return *o.DoorNumber
}

// GetDoorNumberOk returns a tuple with the DoorNumber field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WebhookEventContactAddress) GetDoorNumberOk() (*string, bool) {
	if o == nil || IsNil(o.DoorNumber) {
		return nil, false
	}
	return o.DoorNumber, true
}

// HasDoorNumber returns a boolean if a field has been set.
func (o *WebhookEventContactAddress) HasDoorNumber() bool {
	if o != nil && !IsNil(o.DoorNumber) {
		return true
	}

	return false
}

// SetDoorNumber gets a reference to the given string and assigns it to the DoorNumber field.
func (o *WebhookEventContactAddress) SetDoorNumber(v string) {
	o.DoorNumber = &v
}

// GetCity returns the City field value if set, zero value otherwise.
func (o *WebhookEventContactAddress) GetCity() string {
	if o == nil || IsNil(o.City) {
		var ret string
		return ret
	}
	return *o.City
}

// GetCityOk returns a tuple with the City field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WebhookEventContactAddress) GetCityOk() (*string, bool) {
	if o == nil || IsNil(o.City) {
		return nil, false
	}
	return o.City, true
}

// HasCity returns a boolean if a field has been set.
func (o *WebhookEventContactAddress) HasCity() bool {
	if o != nil && !IsNil(o.City) {
		return true
	}

	return false
}

// SetCity gets a reference to the given string and assigns it to the City field.
func (o *WebhookEventContactAddress) SetCity(v string) {
	o.City = &v
}

// GetZip returns the Zip field value if set, zero value otherwise.
func (o *WebhookEventContactAddress) GetZip() string {
	if o == nil || IsNil(o.Zip) {
		var ret string
		return ret
	}
	return *o.Zip
}

// GetZipOk returns a tuple with the Zip field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WebhookEventContactAddress) GetZipOk() (*string, bool) {
	if o == nil || IsNil(o.Zip) {
		return nil, false
	}
	return o.Zip, true
}

// HasZip returns a boolean if a field has been set.
func (o *WebhookEventContactAddress) HasZip() bool {
	if o != nil && !IsNil(o.Zip) {
		return true
	}

	return false
}

// SetZip gets a reference to the given string and assigns it to the Zip field.
func (o *WebhookEventContactAddress) SetZip(v string) {
	o.Zip = &v
}

// GetCountry returns the Country field value if set, zero value otherwise.
func (o *WebhookEventContactAddress) GetCountry() string {
	if o == nil || IsNil(o.Country) {
		var ret string
		return ret
	}
	return *o.Country
}

// GetCountryOk returns a tuple with the Country field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WebhookEventContactAddress) GetCountryOk() (*string, bool) {
	if o == nil || IsNil(o.Country) {
		return nil, false
	}
	return o.Country, true
}

// HasCountry returns a boolean if a field has been set.
func (o *WebhookEventContactAddress) HasCountry() bool {
	if o != nil && !IsNil(o.Country) {
		return true
	}

	return false
}

// SetCountry gets a reference to the given string and assigns it to the Country field.
func (o *WebhookEventContactAddress) SetCountry(v string) {
	o.Country = &v
}

func (o WebhookEventContactAddress) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o WebhookEventContactAddress) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Street) {
		toSerialize["street"] = o.Street
	}
	if !IsNil(o.StreetNumber) {
		toSerialize["street_number"] = o.StreetNumber
	}
	if !IsNil(o.DoorNumber) {
		toSerialize["door_number"] = o.DoorNumber
	}
	if !IsNil(o.City) {
		toSerialize["city"] = o.City
	}
	if !IsNil(o.Zip) {
		toSerialize["zip"] = o.Zip
	}
	if !IsNil(o.Country) {
		toSerialize["country"] = o.Country
	}
	return toSerialize, nil
}

type NullableWebhookEventContactAddress struct {
	value *WebhookEventContactAddress
	isSet bool
}

func (v NullableWebhookEventContactAddress) Get() *WebhookEventContactAddress {
	return v.value
}

func (v *NullableWebhookEventContactAddress) Set(val *WebhookEventContactAddress) {
	v.value = val
	v.isSet = true
}

func (v NullableWebhookEventContactAddress) IsSet() bool {
	return v.isSet
}

func (v *NullableWebhookEventContactAddress) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableWebhookEventContactAddress(val *WebhookEventContactAddress) *NullableWebhookEventContactAddress {
	return &NullableWebhookEventContactAddress{value: val, isSet: true}
}

func (v NullableWebhookEventContactAddress) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableWebhookEventContactAddress) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


